diff --git a/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
index afcd2da8d..f02f1a0da 100644
--- a/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
@@ -12,6 +12,8 @@ import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.monster.SlimeMob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
@@ -38,7 +40,7 @@ public class TrommelBlockEntity extends BlockEntity
         currentItemBurnTime = 0;
         itemPopTime = 0;
         maxBurnTime = 50;
-        rand = new Random();
+        random = new Random();
         nextToSieve = 1;
 //        for (ItemStack i : trommellableItems){
 //            simulateTrommelDrops(64 , i);
@@ -174,16 +176,20 @@ public class TrommelBlockEntity extends BlockEntity
         {
             burnTime--;
         }
-        if(worldObj != null && !worldObj.isClientSide)
+        if(worldObj == null || !worldObj.isClientSide)
         {
-        	if(worldObj.getBlockId(x, y, z) == Blocks.TROMMEL_IDLE.id) {
+        	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.TROMMEL_IDLE.id) {
             	if(currentItemBurnTime == 0 && itemStacks[0] == null) {
             		if(itemStacks[4] != null && itemStacks[4].itemID == Blocks.NETHERRACK.id) {
             			itemStacks[4].stackSize--;
             			if(itemStacks[4].stackSize <= 0) itemStacks[4] = null;
-            			TrommelBlock.updateTrommelBlockState(true, worldObj, x, y, z);
-            			flag1 = true;
-            		}
+            			if (worldObj != null) {
+                            TrommelBlock.updateTrommelBlockState(true, worldObj, x, y, z);
+                        } else if (carriedBlock != null) {
+                            carriedBlock.block = Blocks.TROMMEL_ACTIVE;
+                        }
+                        flag1 = true;
+                    }
             	}
         	}
             if(!canProduce(nextToSieve))
@@ -225,7 +231,11 @@ public class TrommelBlockEntity extends BlockEntity
             if(isBurning != (burnTime > 0))
             {
                 flag1 = true;
-                TrommelBlock.updateTrommelBlockState(burnTime > 0, worldObj, x, y, z);
+                if (worldObj != null) {
+                    TrommelBlock.updateTrommelBlockState(burnTime > 0, worldObj, x, y, z);
+                } else if (carriedBlock != null) {
+                    carriedBlock.block = burnTime > 0 ? Blocks.TROMMEL_ACTIVE : Blocks.TROMMEL_IDLE;
+                }
             }
         }
         if(flag1)
@@ -236,9 +246,7 @@ public class TrommelBlockEntity extends BlockEntity
 
     private boolean canProduce(int slotIndex)
     {
-        if(itemStacks[slotIndex] != null && canItemBeTrommeled(itemStacks[slotIndex]))
-            return true;
-        return false;
+        return itemStacks[slotIndex] != null && canItemBeTrommeled(itemStacks[slotIndex]);
     }
 
     public void sieveItem(int slotIndex)
@@ -259,28 +267,31 @@ public class TrommelBlockEntity extends BlockEntity
         	// Check if chest is adjacent
         	int xOffset = 0;
         	int zOffset = 0;
-        	int meta = worldObj.getBlockMetadata(x, y, z) & 0x07;
-        	if (meta == 2)
-        	{
-        		xOffset = -1;
-        	}
-        	else if (meta == 5)
-        	{
-        		zOffset = -1;
-        	}
-        	else if (meta == 3)
-        	{
-        		xOffset = 1;
-        	}
-        	else if (meta == 4)
-        	{
-        		zOffset = 1; 
-        	}
-        	int adjacentId = worldObj.getBlockId(x + xOffset, y, z + zOffset);
+        	if (worldObj != null) {
+                int meta = worldObj.getBlockMetadata(x, y, z) & 0x07;
+                if (meta == 2)
+                {
+                    xOffset = -1;
+                }
+                else if (meta == 5)
+                {
+                    zOffset = -1;
+                }
+                else if (meta == 3)
+                {
+                    xOffset = 1;
+                }
+                else if (meta == 4)
+                {
+                    zOffset = 1;
+                }
+            }
+        	int adjacentId = worldObj != null ? worldObj.getBlockId(x + xOffset, y, z + zOffset) : 0;
         	
         	Container chest = null;
         	if (Block.blocksList[adjacentId] instanceof ChestBlock) {
-        		chest = ChestBlock.getInventory(worldObj, x + xOffset, y, z + zOffset);
+                assert worldObj != null;
+                chest = ChestBlock.getInventory(worldObj, x + xOffset, y, z + zOffset);
         	}
         	
         	if (chest != null)
@@ -305,34 +316,43 @@ public class TrommelBlockEntity extends BlockEntity
         			ItemStack slot = chest.getItem(i);
         			if (slot == null)
         			{
-
         				chest.setItem(i, itemResult);
         				return;
         			}
         		}
         	}
             if(itemResult.stackSize > 0) {
-            	worldObj.dropItem(x, y, z, itemResult);
+                if (worldObj != null) {
+                    worldObj.dropItem(x, y, z, itemResult);
+                } else if (carriedBlock != null) {
+                    carriedBlock.world.dropItem(MathHelper.floor(carriedBlock.holder.x), MathHelper.floor(carriedBlock.holder.y), MathHelper.floor(carriedBlock.holder.z), itemResult);
+                }
+
             }
         }
-        if(rand.nextInt(4000)==0) {
+        if(random.nextInt(4000)==0) {
 
             float f = (((float) 1 - 0.5F)) / 4F;
             float f1 = (((float) 1 - 0.5F)) / 4F;
-            SlimeMob entityslime = new SlimeMob(worldObj);
-            entityslime.setSlimeSize(1);
-            entityslime.moveTo(x + (double)f, y + 1D, z + (double)f1, rand.nextFloat() * 360F, 0.0F);
+            SlimeMob slimeMob = new SlimeMob(carriedBlock != null ? carriedBlock.world : worldObj);
+            slimeMob.setSlimeSize(1);
             float f3 = 0.05F;
-            entityslime.xd = (float) rand.nextGaussian() * f3;
-            entityslime.yd = (float) rand.nextGaussian() * f3 + 0.2F;
-            entityslime.zd = (float) rand.nextGaussian() * f3;
-            worldObj.entityJoinedWorld(entityslime);
+            slimeMob.xd = (float) random.nextGaussian() * f3;
+            slimeMob.yd = (float) random.nextGaussian() * f3 + 0.2F;
+            slimeMob.zd = (float) random.nextGaussian() * f3;
+            if (worldObj != null) {
+                slimeMob.moveTo(x + (double)f, y + 1D, z + (double)f1, random.nextFloat() * 360F, 0.0F);
+                worldObj.entityJoinedWorld(slimeMob);
+            } else if (carriedBlock != null) {
+                slimeMob.moveTo(carriedBlock.holder.x + (double)f, carriedBlock.holder.y + 1D, carriedBlock.holder.z + (double)f1, random.nextFloat() * 360F, 0.0F);
+                carriedBlock.world.entityJoinedWorld(slimeMob);
+            }
         }
     }
 
     private ItemStack getItemResult(ItemStack slotItem)
     {
-        if(rand.nextInt(2) != 0)
+        if(random.nextInt(2) != 0)
             return null;
         List<RecipeEntryTrommel> list = Registries.RECIPES.getAllTrommelRecipes();
         for (RecipeEntryTrommel recipe : list) {
@@ -380,6 +400,44 @@ public class TrommelBlockEntity extends BlockEntity
         // Do nothing
     }
 
+    @Override
+    public void dropContents(World world, int x, int y, int z) {
+        super.dropContents(world, x, y, z);
+        if (!TrommelBlock.keepTrommelInventory)
+        {
+            if(world.getBlockEntity(x, y, z) != null)
+            {
+                label0:
+                for (int l = 0; l < getContainerSize(); l++)
+                {
+                    ItemStack itemstack = getItem(l);
+                    if (itemstack == null) {
+                        continue;
+                    }
+                    float f = random.nextFloat() * 0.8F + 0.1F;
+                    float f1 = random.nextFloat() * 0.8F + 0.1F;
+                    float f2 = random.nextFloat() * 0.8F + 0.1F;
+                    do {
+                        if (itemstack.stackSize <= 0) {
+                            continue label0;
+                        }
+                        int i1 = random.nextInt(21) + 10;
+                        if (i1 > itemstack.stackSize) {
+                            i1 = itemstack.stackSize;
+                        }
+                        itemstack.stackSize -= i1;
+                        ItemEntity item = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                        float f3 = 0.05F;
+                        item.xd = (float) random.nextGaussian() * f3;
+                        item.yd = (float) random.nextGaussian() * f3 + 0.2F;
+                        item.zd = (float) random.nextGaussian() * f3;
+                        world.entityJoinedWorld(item);
+                    } while (true);
+                }
+            }
+        }
+    }
+
     private void simulateTrommelDrops(int passes, ItemStack blockToTest){
         Map<Object, Integer> trommelDropMap = new HashMap<>();
         System.out.println();
@@ -442,6 +500,21 @@ public class TrommelBlockEntity extends BlockEntity
         trommel.simulateTrommelDrops(10000, Blocks.DIRT_SCORCHED_RICH.getDefaultStack());
     }
 
+    @Override
+    public void heldTick(World world, Entity holder) {
+        tick();
+    }
+
+    @Override
+    public boolean canBeCarried(World world, Entity potentialHolder) {
+        return true;
+    }
+
+    @Override
+    public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
+        return super.getCarriedEntry(world, holder, currentBlock, (currentMeta & ~0b111) | 0b010 /*Reset rotation, primarily to make it render in hand properly*/);
+    }
+
     private static final Logger LOGGER = LogUtils.getLogger();
     private ItemStack[] itemStacks;
 
@@ -450,5 +523,5 @@ public class TrommelBlockEntity extends BlockEntity
     public int itemPopTime;
     private final int maxBurnTime;
     private int nextToSieve;
-    private final Random rand;
+    private final Random random;
 }
diff --git a/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java b/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
index 05b2a0555..42e14c874 100644
--- a/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
@@ -84,40 +84,40 @@ public class BasePistonBlock extends Block
     }
 
     private boolean getNeighborSignal(World world, int x, int y, int z, int direction) {
-        if(direction != 0 && world.isBlockIndirectlyProvidingPowerTo(x, y - 1, z, Side.BOTTOM)) {
+        if(direction != 0 && world.getSignal(x, y - 1, z, Side.BOTTOM)) {
             return true;
         }
-        if(direction != 1 && world.isBlockIndirectlyProvidingPowerTo(x, y + 1, z, Side.TOP)) {
+        if(direction != 1 && world.getSignal(x, y + 1, z, Side.TOP)) {
             return true;
         }
-        if(direction != 2 && world.isBlockIndirectlyProvidingPowerTo(x, y, z - 1, Side.NORTH)) {
+        if(direction != 2 && world.getSignal(x, y, z - 1, Side.NORTH)) {
             return true;
         }
-        if(direction != 3 && world.isBlockIndirectlyProvidingPowerTo(x, y, z + 1, Side.SOUTH)) {
+        if(direction != 3 && world.getSignal(x, y, z + 1, Side.SOUTH)) {
             return true;
         }
-        if(direction != 5 && world.isBlockIndirectlyProvidingPowerTo(x + 1, y, z, Side.EAST)) {
+        if(direction != 5 && world.getSignal(x + 1, y, z, Side.EAST)) {
             return true;
         }
-        if(direction != 4 && world.isBlockIndirectlyProvidingPowerTo(x - 1, y, z, Side.WEST)) {
+        if(direction != 4 && world.getSignal(x - 1, y, z, Side.WEST)) {
             return true;
         }
-        if(world.isBlockIndirectlyProvidingPowerTo(x, y, z, Side.BOTTOM)) {
+        if(world.getSignal(x, y, z, Side.BOTTOM)) {
             return true;
         }
-        if(world.isBlockIndirectlyProvidingPowerTo(x, y + 2, z, Side.TOP)) {
+        if(world.getSignal(x, y + 2, z, Side.TOP)) {
             return true;
         }
-        if(world.isBlockIndirectlyProvidingPowerTo(x, y + 1, z - 1, Side.NORTH)) {
+        if(world.getSignal(x, y + 1, z - 1, Side.NORTH)) {
             return true;
         }
-        if(world.isBlockIndirectlyProvidingPowerTo(x, y + 1, z + 1, Side.SOUTH)) {
+        if(world.getSignal(x, y + 1, z + 1, Side.SOUTH)) {
             return true;
         }
-        if(world.isBlockIndirectlyProvidingPowerTo(x - 1, y + 1, z, Side.WEST)) {
+        if(world.getSignal(x - 1, y + 1, z, Side.WEST)) {
             return true;
         }
-        return world.isBlockIndirectlyProvidingPowerTo(x + 1, y + 1, z, Side.EAST);
+        return world.getSignal(x + 1, y + 1, z, Side.EAST);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
index 60f1f042e..e03fe5436 100644
--- a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.phys.AABB;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.logic.PistonDirections;
+import net.minecraft.core.world.World;
 
 import java.util.*;
 
@@ -185,6 +186,11 @@ public class MovingPistonBlockEntity extends BlockEntity
         tag.putBoolean("extending", extending);
     }
 
+    @Override
+    public boolean canBeCarried(World world, Entity potentialHolder) {
+        return false;
+    }
+
     private int movedId;
     private int movedData;
     private int direction;
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index 20f667b75..62350c855 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -3,6 +3,7 @@ package net.minecraft.core.entity;
 import java.util.List;
 import java.util.Random;
 
+import net.minecraft.core.world.ICarriable;
 import org.jetbrains.annotations.Nullable;
 
 import com.mojang.nbt.CompoundTag;
@@ -1293,10 +1294,14 @@ public abstract class Entity
     {
     }
 
-    public void setEquippedSlot(int i, int j, int k, CompoundTag tag)
+    public void setEquippedSlot(int slot, int itemID, int itemMeta, CompoundTag tag)
     {
     }
 
+    public void setHeldObject(@Nullable ICarriable heldObject) {
+
+    }
+
     public boolean isOnFire()
     {
         return !fireImmune && remainingFireTicks > 0 || getSharedFlag(FLAG_ONFIRE);
diff --git a/src/main/java/net/minecraft/core/entity/PaintingEntity.java b/src/main/java/net/minecraft/core/entity/PaintingEntity.java
index 66ebccf92..af730d430 100644
--- a/src/main/java/net/minecraft/core/entity/PaintingEntity.java
+++ b/src/main/java/net/minecraft/core/entity/PaintingEntity.java
@@ -313,7 +313,7 @@ public class PaintingEntity extends Entity
             setStack(new ItemStack(stack.getItem(), 1, stack.getMetadata()));
             stack.consumeItem(player);
             if (stack.stackSize <= 0) {
-                player.inventory.setItem(player.inventory.currentItem, null);
+                player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
             }
             if (paintingStack != null && player.getGamemode().consumeBlocks()){
                 player.inventory.insertItem(paintingStack, true);
diff --git a/src/main/java/net/minecraft/core/entity/animal/WolfMob.java b/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
index eef1e84b7..6165bd753 100644
--- a/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
@@ -665,7 +665,7 @@ public class WolfMob extends Animal
                 itemstack.consumeItem(entityplayer);
                 if(itemstack.stackSize <= 0)
                 {
-                    entityplayer.inventory.setItem(entityplayer.inventory.currentItem, null);
+                    entityplayer.inventory.setItem(entityplayer.inventory.getCurrentItemIndex(), null);
                 }
                 if(!world.isClientSide)
                 {
@@ -698,7 +698,7 @@ public class WolfMob extends Animal
                 		itemstack.stackSize--;
                 		if(itemstack.stackSize <= 0)
                 		{
-                			entityplayer.inventory.setItem(entityplayer.inventory.currentItem, null);
+                			entityplayer.inventory.setItem(entityplayer.inventory.getCurrentItemIndex(), null);
                 		}                		
                 	}
                     heal(((FoodItem)Items.FOOD_PORKCHOP_RAW).getHealAmount());
@@ -716,7 +716,7 @@ public class WolfMob extends Animal
                     if (entityplayer.getGamemode().consumeBlocks()) {
                         itemstack.stackSize--;
                         if (itemstack.stackSize <= 0) {
-                            entityplayer.inventory.setItem(entityplayer.inventory.currentItem, null);
+                            entityplayer.inventory.setItem(entityplayer.inventory.getCurrentItemIndex(), null);
                         }
                     }
                     return true;
diff --git a/src/main/java/net/minecraft/core/entity/player/Player.java b/src/main/java/net/minecraft/core/entity/player/Player.java
index b580af12f..af732e9aa 100644
--- a/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -61,11 +61,13 @@ import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.weather.Weathers;
 import net.minecraft.server.entity.player.ServerPlayer;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
 import java.util.Comparator;
@@ -108,7 +110,8 @@ public abstract class Player extends Mob
     public float timeInPortal;
     public float prevTimeInPortal;
     private final int damageRemainder;
-    public FishingBobberEntity bobberEntity;
+    public @Nullable FishingBobberEntity bobberEntity;
+    protected @Nullable ICarriable heldObject;
     public volatile String skinURL;
     public volatile String capeURL;
     public boolean slimModel = false;
@@ -236,6 +239,9 @@ public abstract class Player extends Mob
             }
         }
         super.tick();
+        if (heldObject != null) {
+            heldObject.heldTick(world, this);
+        }
 
         if(!world.isClientSide && craftingInventory != null && !craftingInventory.stillValid(this))
         {
@@ -413,11 +419,17 @@ public abstract class Player extends Mob
         {
             dropPlayerItemWithRandomChoice(new ItemStack(Items.SIGN, 1), true);
         }
+
         if (!world.getGameRuleValue(GameRules.KEEP_INVENTORY))
         {
             craftingInventory.onCraftGuiClosed(this);
             inventory.dropAllItems();
         }
+        if (heldObject != null) { // TODO consider whether making the held object kept with keep inventory is a good idea
+            heldObject.drop(world, this);
+            heldObject = null;
+        }
+
         if(entityKilledBy != null)
         {
             xd = -MathHelper.cos(((attackedAtYaw + yRot) * MathHelper.PI) / 180F) * 0.1F;
@@ -596,7 +608,7 @@ public abstract class Player extends Mob
 
     public void dropCurrentItem(boolean dropFullStack)
     {
-        dropPlayerItemWithRandomChoice(inventory.removeItem(inventory.currentItem, dropFullStack ? 64 : 1), false);
+        dropPlayerItemWithRandomChoice(inventory.removeItem(inventory.getCurrentItemIndex(), dropFullStack ? 64 : 1), false);
     }
 
     public void dropPlayerItem(ItemStack itemstack)
@@ -606,8 +618,18 @@ public abstract class Player extends Mob
 
     public void setHotbarOffset(int offset)
     {
-        inventory.hotbarOffset = offset;
+        inventory.setHotbarOffset(offset, false);
     }
+
+    @Override
+    public void setHeldObject(@Nullable ICarriable heldObject) {
+        this.heldObject = heldObject;
+    }
+
+    public @Nullable ICarriable getHeldObject() {
+        return heldObject;
+    }
+
     @Override
     public boolean isPickable() {
         if (getGamemode().canInteract()){
@@ -706,6 +728,8 @@ public abstract class Player extends Mob
         super.readAdditionalSaveData(tag);
         ListTag nbttaglist = tag.getList("Inventory");
         inventory.readFromNBT(nbttaglist);
+        inventory.setCurrentItemIndex(tag.getIntegerOrDefault("CurrentItem", inventory.getCurrentItemIndex()), true);
+        inventory.setHotbarOffset(tag.getIntegerOrDefault("HotbarOffset", inventory.getHotbarOffset()), true);
         int dim = tag.getInteger("Dimension");
         if (dim == -1) dim = 1;
         dimension = dim;
@@ -726,6 +750,10 @@ public abstract class Player extends Mob
         {
             lastDeathCoordinate = new ChunkCoordinates(tag.getInteger("LastDeathX"), tag.getInteger("LastDeathY"), tag.getInteger("LastDeathZ"));
         }
+        if (tag.containsKey("HeldObject")) {
+            CompoundTag heldTag = tag.getCompound("HeldObject");
+            heldObject = ICarriable.createAndLoadCarriable(this, heldTag);
+        }
     }
 
     @Override
@@ -733,6 +761,8 @@ public abstract class Player extends Mob
     {
         super.addAdditionalSaveData(tag);
         tag.put("Inventory", inventory.writeToNBT(new ListTag()));
+        tag.putInt("CurrentItem", inventory.getCurrentItemIndex());
+        tag.putInt("HotbarOffset", inventory.getHotbarOffset());
         tag.putInt("Dimension", dimension);
         tag.putBoolean("Sleeping", sleeping);
         tag.putShort("SleepTimer", (short)sleepTimer);
@@ -751,6 +781,12 @@ public abstract class Player extends Mob
             tag.putInt("LastDeathY", lastDeathCoordinate.y);
             tag.putInt("LastDeathZ", lastDeathCoordinate.z);
         }
+
+        if (heldObject != null) {
+            CompoundTag heldTag = new CompoundTag();
+            heldObject.writeToNBT(heldTag);
+            tag.put("HeldObject", heldTag);
+        }
     }
 
     @Override
@@ -978,7 +1014,7 @@ public abstract class Player extends Mob
 
     public void destroyCurrentEquippedItem()
     {
-        inventory.setItem(inventory.currentItem, null);
+        inventory.setItem(inventory.getCurrentItemIndex(), null);
     }
 
     @Override
@@ -1492,20 +1528,20 @@ public abstract class Player extends Mob
     	
 		//Find item in hotbar, and select it
 		for(int i=0; i < 9; i++) {
-			ItemStack stack = inventory.getItem(i + inventory.hotbarOffset);
+			ItemStack stack = inventory.getItem(i + inventory.getHotbarOffset());
 			if(stack != null && stack.itemID == selectItem.itemID && stack.getMetadata() == selectItem.getMetadata()) {
-				setCurrentItem(i + inventory.hotbarOffset);
+				setCurrentItem(i + inventory.getHotbarOffset());
 				return;
 			}
 		}
 		
 		//Find empty hotbar slot
 		int emptyHotbarSlot = -1;
-		int slot = inventory.currentItem;
+		int slot = inventory.getCurrentItemIndex();
 		for(int i=0; i < 9; i++) {
-			if(inventory.getItem(i + inventory.hotbarOffset) == null) {
-				emptyHotbarSlot = i + inventory.hotbarOffset;
-				slot = i + inventory.hotbarOffset;
+			if(inventory.getItem(i + inventory.getHotbarOffset()) == null) {
+				emptyHotbarSlot = i + inventory.getHotbarOffset();
+				slot = i + inventory.getHotbarOffset();
 				break;
 			}
 		}
@@ -1533,7 +1569,7 @@ public abstract class Player extends Mob
 					}
 				}
 				
-				int createItemInsertSlot = emptyHotbarSlot != -1 ? emptyHotbarSlot : inventory.currentItem;
+				int createItemInsertSlot = emptyHotbarSlot != -1 ? emptyHotbarSlot : inventory.getCurrentItemIndex();
 				selectItem.stackSize = 1;
 				if(emptySlot != -1) {
 					swapItems(emptySlot, createItemInsertSlot);
@@ -1550,7 +1586,7 @@ public abstract class Player extends Mob
     }
     
     public void setCurrentItem(int i) {
-        inventory.currentItem = i;
+        inventory.setCurrentItemIndex(i, false);
     }
     
     public void swapItems(int slot1, int slot2) {
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/BoatEntity.java b/src/main/java/net/minecraft/core/entity/vehicle/BoatEntity.java
index c5639823a..bcdba4599 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/BoatEntity.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/BoatEntity.java
@@ -494,7 +494,7 @@ public class BoatEntity extends Entity
             if (entityplayer.getHeldItem() != null && entityplayer.getHeldItem().itemID == Items.FLAG.id && flag == null)
             {
                 this.flag = entityplayer.getHeldItem().copy();
-                entityplayer.inventory.setItem(entityplayer.inventory.currentItem, null);
+                entityplayer.inventory.setItem(entityplayer.inventory.getCurrentItemIndex(), null);
                 createTileEntity();
                 world.sendTrackedEntityDataPacket(this);
                 return true;
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
index f4e610050..934ca02ee 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
@@ -5,6 +5,8 @@ import com.mojang.nbt.ListTag;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.RailBlock;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.ChestBlockEntity;
 import net.minecraft.core.block.logic.RailDirection;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.entity.Entity;
@@ -692,6 +694,19 @@ public class MinecartEntity extends Entity implements Container {
 	public boolean interact(Player player) {
         switch (type){
             case PASSENGER_CART:
+                if (!world.isClientSide && passenger == null && player.isSneaking() && player.getHeldObject() instanceof BlockEntity.CarriedBlock) {
+                    BlockEntity.CarriedBlock carriedBlock = (BlockEntity.CarriedBlock) player.getHeldObject();
+                    if (carriedBlock.entity instanceof ChestBlockEntity) {
+                        ChestBlockEntity chest = (ChestBlockEntity) carriedBlock.entity;
+                        this.type = CHEST_CART;
+                        for (int i = 0; i < this.getContainerSize(); i++) {
+                            this.setItem(i, chest.getItem(i));
+                            chest.setItem(i, null);
+                        }
+                        player.setHeldObject(null);
+                        return true;
+                    }
+                }
                 if(passenger != null && (passenger instanceof Player) && passenger != player) {
                     return true;
                 }
@@ -701,7 +716,19 @@ public class MinecartEntity extends Entity implements Container {
                 break;
             case CHEST_CART:
                 if(!world.isClientSide) {
-                    player.displayContainerScreen(this);
+                    if (player.isSneaking()) {
+                        ChestBlockEntity blockEntity = new ChestBlockEntity();
+                        for (int i = 0; i < this.getContainerSize(); i++) {
+                            blockEntity.setItem(i, this.getItem(i));
+                            this.setItem(i, null);
+                        }
+                        blockEntity.worldObj = null;
+                        blockEntity.carriedBlock = blockEntity.getCarriedEntry(world, player, Blocks.CHEST_PLANKS_OAK, 0);
+                        player.setHeldObject(blockEntity.carriedBlock);
+                        this.type = PASSENGER_CART;
+                    } else {
+                        player.displayContainerScreen(this);
+                    }
                 }
                 break;
             case FURNACE_CART:
@@ -709,7 +736,7 @@ public class MinecartEntity extends Entity implements Container {
                 if(itemstack != null && LookupFuelFurnace.instance.getFuelYield(itemstack.itemID) > 0) {
                     if(--itemstack.stackSize <= 0)
                     {
-                        player.inventory.setItem(player.inventory.currentItem, null);
+                        player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
                     }
                     fuel += (int) ((LookupFuelFurnace.instance.getFuelYield(itemstack.itemID)/1600F) * 1200);
                 }
diff --git a/src/main/java/net/minecraft/core/item/DoorItem.java b/src/main/java/net/minecraft/core/item/DoorItem.java
index 1f09354a2..24df706cd 100644
--- a/src/main/java/net/minecraft/core/item/DoorItem.java
+++ b/src/main/java/net/minecraft/core/item/DoorItem.java
@@ -58,13 +58,15 @@ public class DoorItem extends Item {
 			meta |= 0x8;
 		}
 		
-		world.editingBlocks = true;
+		world.noNeighborUpdate = true;
 		world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, doorBlockBottom.id, meta);
 		world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, doorBlockTop.id, meta);
-		world.editingBlocks = false;
+		world.noNeighborUpdate = false;
 		world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id);
 		world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id);
 		world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, doorBlockBottom, EnumBlockSoundEffectType.PLACE);
+		doorBlockBottom.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, entityplayer, yPlaced);
+		doorBlockTop.onBlockPlacedByMob(world, blockX, blockY + 1, blockZ, side, entityplayer, yPlaced);
 		itemstack.consumeItem(entityplayer);
 		return true;
 	}
diff --git a/src/main/java/net/minecraft/core/item/EmptyBucketItem.java b/src/main/java/net/minecraft/core/item/EmptyBucketItem.java
index db4931281..f0ad17c3c 100644
--- a/src/main/java/net/minecraft/core/item/EmptyBucketItem.java
+++ b/src/main/java/net/minecraft/core/item/EmptyBucketItem.java
@@ -77,7 +77,7 @@ public class EmptyBucketItem extends Item
 
     public static boolean useBucket(Player player, ItemStack itemToGive) {
         if(player.inventory.getCurrentItem().stackSize <= 1) {
-            player.inventory.setItem(player.inventory.currentItem, itemToGive);
+            player.inventory.setItem(player.inventory.getCurrentItemIndex(), itemToGive);
             return true;
         } else {
         	player.inventory.insertItem(itemToGive, true);
